(*************************************************************************
*                                                                        *
*                                                                        *
*    unit   E N T E R   &   S C R E E N        Test-Version 1.03         *
*                                                                        *
*                                                                        *
**************************************************************************
    *                                                                    *
    *                                                                    *
    *  J. Desteffani IA85                      4.12.1986 - 31.01.1986    *
    *                                                                    *
    *                                                                    *
    *  p u r p o s e :                                                   *
    *                                                                    *
    *  Erleichter und sichert die Eingabe sowie (spaeter) die            *
    *  Bidschirmausgabe.                                                 *
    *  Eingabeprozeduren get_* verkraften auch die faelschesten          *
    *  Eingaben und melden dies mit einer Fehlermeldung.                 *
    *  Dieses Programm soll auf der PR1ME lauffaehig werden (Kraetke)!   *
    *  Die Prozeduren get_m_* testen ob der eingegebene Wert in einem    *
    *  gewuenschten Bereich liegt.                                       *
    *  Die Prozeduren get_*_inkl akzeptieren auch eine `Null`-Eingabe.   *
    *                                                                    *

    *  Version 1.01: Proceduren get_Matrix & get_real_inkl.              *
    *                                                                    *
    *  Version 1.02: Zusaetzlich WORKING - Anzeige.                      *
    *                Sonstige kleinere Aenderungen.                      *
    *                                                                    *
    *  Version 1.03: Procedure get_Matrix entfernen.                     *
    *                Xinput Procedure & entries aendern.                 *
    *                weiter get_*_inkl Proceduren implementiereen        *
    *                                                                    *
    *  e n t r i e s :                                                   *
    *                                                                    *
    *  FUNCTION                                                          *
    *  --------                                                          *
    *     get_boolean    (T_Message_Str): boolean;                       *
    *     get_char       (T_Message_Str): char;                          *
    *     get_integer    (T_Message_Str): integer;                       *
    *     get_real       (T_Message_Str): real;                          *
    *     get_String     (T_Message_Str): T_Enter_String;                *
    *     get_m_char     (T_Message_Str; T_char_Menge): char;            *
    *     get_m_integer  (T_Message_Str; low, high :integer): integer;   *
    *     get_m_real     (T_Message_Str; low, high :integer): real;      *
    *     get_m_String   (T_Message_Str; integer): T_Enter_String;       *
    *                                                                    *
    *  PROCEDURE                                                         *
    *  ---------                                                         *
    *     get_boolean_inkl (T_Message_Str, VAR boolean, boolean);        *
    *     get_char_inkl    (T_Message_Str, VAR real, boolean);           *
    *     get_integer_inkl (T_Message_Str, var integer, boolean);        *
    *     get_real_inkl    (T_Message_Str, var real, boolean);           *
    *     get_String_inkl  (T_Message_Str, VAR String, boolean);         *
    *                                                                    *
    *                                                                    *
    *  g l o b a l    a g r e e m e n t s :                              *
    *                                                                    *
    *  CONST                                                             *
    *     Enter_Line  = 25;             (Nummer der Eingabezeile)        *
    *     max_Enter   = 80;             (max. Laenge einer Eingabe)      *
    *     max_Message = 80;             (max. Laenge einer Meldung)      *
    *                                                                    *
    *  TYPE                                                              *
    *     T_Message_Str   = String [max_Enter];                          *
    *     T_Enter_String  = String [max_Message];                        *
    *     T_char_Menge    = SET OF char;                                 *
    *     T_Typenmenge    = SET OF (nullT,                               *
    *                               booleanT,                            *
    *                               charT,                               *
    *                               integerT,                            *
    *                               realT,                               *
    *                               StringT)                             *
    *     T_Typenrecord   = RECORD                                       *
    *                          charX          :char;                     *
    *                          integerX       :integer;                  *
    *                          realX          :real;                     *
    *                          StringX        :T_Enter_String;           *
    *                          booleanX       :boolean;                  *
    *                       END;                                         *
    *                                                                    *
    *  VAR                                                               *
    *     (no VAR's !)                                                   *
    *                                                                    *
    **********************************************************************)


   (**********************************************************************
   *                                                                     *
   *       PR1ME - spezifische   Functions & Procedures                  *
   *                                                                     *
   ***********************************************************************)

(*
   PROCEDURE gotoXY (x, y :integer);                  EXTERN;
   PROCEDURE delLine                                  EXTERN;
   PROCEDURE clrScr;                                  EXTERN;
   FUNCTION  whereX: integer;                         EXTERN;
   FUNCTION  whereY: integer;                         EXTERN;
   FUNCTION  KeyPressed: boolean;                     EXTERN;
   FUNCTION  C (Str :String; x :integer): char        EXTERN;
*)

   (**********************************************************************
   *                                                                     *
   *       PC - spezifische   Functions & Procedures                     *
   *                                                                     *
   ***********************************************************************)

   FUNCTION C (Str :T_Enter_String; x :integer): char;
   BEGIN
      C:= Str[x];
   END;


(*************************************************************************
*                                                                        *
*          ENTER & SCREEN   -  Functions & Procedures                    *
*                                                                        *
**************************************************************************)


PROCEDURE Cursor_safe (var Cx, Cy  :integer);
BEGIN
   Cx := whereX;
   Cy := whereY;
END;

(*-------------------------------------------------------------------*)

PROCEDURE Cursor_return (var Cx, Cy  :integer);
BEGIN
   gotoXY (Cx, Cy);
END;

(*-------------------------------------------------------------------*)

PROCEDURE XError (Message :T_Message_Str);

   VAR
      Cx, Cy   :integer;

BEGIN
   Cursor_safe (Cx, Cy);
   gotoXY (1, Enter_Line);
   delLine;
   write ('ERROR   ', Message,'   > press key to retry !');
   REPEAT
   UNTIL KeyPressed;
   Cursor_return (Cx, Cy);
END;

(*-------------------------------------------------------------------*)

PROCEDURE Error_Typ (Enter, really  :T_Typenmenge);

   VAR
      a       :char;
      Cx, Cy  :integer;


   PROCEDURE write_Typ  (a  :T_Typenmenge);
   BEGIN
      IF            NullT    in a THEN  write ('no entry')
      ELSE IF       booleanT in a THEN  write ('boolean')
       ELSE IF      charT    in a THEN  write ('char')
        ELSE IF     integerT in a THEN  write ('integer')
         ELSE IF    realT    in a THEN  write ('real')
          ELSE IF   StringT  in a THEN  write ('String');
   END;


BEGIN
   Cursor_safe (Cx, Cy);
   gotoXY (1, Enter_Line);
   delLine;
   write ('ERROR  ');
   write_Typ (Enter);
   write (' instead of ');
   write_Typ (really);
   write ('   > press key to retry !');
   REPEAT
   UNTIL KeyPressed;
   Cursor_return (Cx, Cy);
END;

(*------------------------------------------------------------------*)

PROCEDURE working;
BEGIN
   gotoXY (1, Enter_Line);
   delLine;
   write ('...working...');
END;

(*------------------------------------------------------------------*)

PROCEDURE Typ_Test (    x          :T_Enter_String;
                    var Menge      :T_Typenmenge;
                    var xx         :T_Typenrecord);

 (* ---------------------------------------
   |                                       |
   |     Test auf Null-Eingabe             |
   |                                       |
    --------------------------------------- *)

   PROCEDURE Null_Test;
   BEGIN
      IF (length(x)=0) THEN BEGIN
         Menge := Menge + [NullT];
      END;
   END;

 (* ---------------------------------------
   |                                       |
   |     Test auf boolean-Eingabe          |
   |                                       |
    --------------------------------------- *)

   PROCEDURE boolean_Test;
   BEGIN
      IF ((length(x)=1) and (C(x, 1) in ['y','j','Y','J','n','N','0','1']))
         or ((x='true') or (x='false') or (x='yes') or (x='no')
         or (x='YES') or (x='NO') or (x='ja') or (x='nein')) THEN BEGIN
         Menge:= Menge + [booleanT];
         IF ((length(x)=1) and (C(x, 1) in ['y','j','Y','J','1']))
            or ((x='true') or (x='yes') or (x='YES') or (x='ja')) THEN BEGIN
            xx.booleanX:= true;
         END
         ELSE BEGIN
            xx.booleanX:= false;
         END;
      END;
   END;

 (* ---------------------------------------
   |                                       |
   |       Test auf char-Eingabe           |
   |                                       |
    --------------------------------------- *)

   PROCEDURE char_Test;
   BEGIN
      IF (length(x)=1) THEN BEGIN
         Menge:= Menge + [charT];
         xx.charX:= C(x, 1);
      END
      ELSE BEGIN
         xx.charX:= chr(0);
      END;
   END;

 (* ---------------------------------------
   |                                       |
   |     Test auf real-integer-Eingabe     |
   |                                       |
    --------------------------------------- *)

   PROCEDURE real_integer_Test;

      VAR
         possible, Dezimalpunkt,
         Durchlauf, Exp_Flag,
         Vorzeichen, Vorzeichen_Exp :boolean;
         Index,
         Exponent, Index_Dez_Pkt    :integer;
         Mantisse                   :real;

   BEGIN
      possible:=       true;
      Dezimalpunkt:=   false;
      Index_Dez_Pkt:=  0;
      Exp_Flag:=       false;
      Vorzeichen:=     false;
      Vorzeichen_Exp:= false;
      Mantisse:=       0.0;
      Exponent:=       0;
      Index:=          1;

      IF length (x) > 0 THEN BEGIN
         REPEAT
            Durchlauf:= false;
            CASE C(x, Index) OF
            '+','-':BEGIN
                      IF Index <> 1 THEN BEGIN
                         possible := false;
                      END
                      ELSE BEGIN
                         IF C(x, Index) = '-' THEN Vorzeichen:= true;
                      END;
                      Durchlauf:= true;
                    END;
            'E','e':BEGIN
                      IF Exp_Flag = true THEN BEGIN
                         possible:= false;
                      END
                      ELSE BEGIN
                         Exp_Flag:= true;
                         Dezimalpunkt:= true;
                         IF Index+1 <= length(x) THEN BEGIN
                            IF C(x,Index+1) in ['+','-'] THEN BEGIN
                               Index:=Index+1;
                               IF C(x,Index) = '-'THEN Vorzeichen_Exp:=true;
                               IF Index+1 > length(x) THEN possible:=false;
                            END;
                         END
                         ELSE BEGIN
                            possible:= false;
                         END;
                      END;
                      Durchlauf := true;
                   END;
           '.'    :BEGIN
                      IF Dezimalpunkt = true THEN BEGIN
                         possible:= false;
                      END
                      ELSE BEGIN
                         Dezimalpunkt:= true;
                      END;
                      Durchlauf := true;
                   END;
          '0','1','2','3','4','5','6','7','8','9':BEGIN
                      IF Exp_Flag THEN BEGIN
                         Exponent:= 10*Exponent + ord(C(x,Index)) - 48;
                      END
                      ELSE BEGIN
                         IF Dezimalpunkt THEN BEGIN
                            Index_Dez_Pkt:= Index_Dez_Pkt + 1;
                         END;
                         Mantisse:= 10*Mantisse + ord(C(x,Index)) - 48;
                      END;
                      Durchlauf := true;
                   END;
            END; (* of case *)
            Index:= Index+1;
            IF Durchlauf = false THEN BEGIN
               possible := false;
            END;
         UNTIL (possible = false) or (Index > length (x));

         IF possible THEN BEGIN
            IF (Exponent<>0) and ((C(x, 1) in ['e','E'])  or
                ((C(x, 2) in ['e','E']) and (C(x, 1) in ['-','+'])))
                THEN BEGIN
                Mantisse:= 1;
            END;
            IF Vorzeichen_Exp THEN Exponent:= -Exponent;
            IF Mantisse <> 0 THEN BEGIN
               IF LN(Mantisse)/LN(10)-Index_Dez_Pkt+Exponent<=38 THEN BEGIN
                  FOR Index:= 1 TO Index_Dez_Pkt DO BEGIN
                     Mantisse:= Mantisse / 10;
                  END;
                  IF Vorzeichen_Exp THEN BEGIN
                     IF Exponent > -200 THEN BEGIN
                        FOR Index:= Exponent TO -1 DO BEGIN
                           Mantisse:= Mantisse / 10;
                        END
                     END
                     ELSE BEGIN
                        Mantisse:= 0;
                     END;
                  END
                  ELSE BEGIN
                     FOR Index:= 1 TO Exponent DO BEGIN
                        Mantisse:= Mantisse * 10;
                     END;
                  END;
                  IF Vorzeichen THEN Mantisse:= -Mantisse;
                  xx.realX:= Mantisse;
                  Menge:= Menge + [realT];
                  IF (Mantisse<=32767) and (Mantisse>=-32767) THEN BEGIN
                     IF round(Mantisse) = Mantisse THEN BEGIN
                        xx.integerX:= round(Mantisse);
                        Menge:= Menge + [integerT];
                     END;
                  END
                  ELSE BEGIN
                     xx.integerX:= 0;
                  END;
               END;
            END
            ELSE BEGIN
               Menge:= Menge + [realT, integerT];
            END;
         END
         ELSE BEGIN
            xx.realX:= 0;
            xx.integerX:= 0;
         END;
      END;
   END;

 (* --------------------------------------
   |                                      |
   |     Test auf String-Eingabe          |
   |                                      |
    -------------------------------------- *)

   PROCEDURE String_Test;
   BEGIN
      IF length(x) > 0 THEN BEGIN
         Menge:= Menge + [StringT];
         xx.StringX:= x;
      END;
   END;


BEGIN
   WITH xx DO BEGIN
      booleanX:= false;
      charX:= chr(0);
      integerX:= 0;
      realX:= 0.0;
      StringX:= '';
   END;
   Menge := [];
   Null_Test;
   boolean_Test;
   char_Test;
   real_integer_Test;
   String_Test;
END;

(*------------------------------------------------------------------*)

PROCEDURE Xinput (    Message      :T_Enter_String;
                  VAR Wunsch_Menge :T_Typenmenge;
                  VAR Typen_Record :T_Typenrecord);

   VAR
      possible    :boolean;
      Cx, Cy      :integer;
      Enter       :T_Enter_String;
      Typen_Menge :T_Typenmenge;

BEGIN
   Cursor_safe (Cx, Cy);
   REPEAT
      Typen_Menge:= Wunsch_Menge;
      gotoXY (1, Enter_Line);
      delLine;
      write (Message);
      Enter:='';
      read (Enter);
      working;
      Typ_Test (Enter, Typen_Menge, Typen_Record);
      IF (Wunsch_Menge * Typen_Menge) <> [] THEN BEGIN
         possible:= true;
      END
      ELSE BEGIN
         possible:= false;
         Error_Typ (Typen_Menge, Wunsch_Menge);
      END;
   UNTIL possible;
   Wunsch_Menge:= Typen_Menge;
   Cursor_return (Cx, Cy);
END;

(*-------------------------------------------------------------------*)

FUNCTION get_boolean  (Message: T_Message_Str): boolean;

   VAR
      Typen_Menge    :T_Typenmenge;
      Typen_Record   :T_Typenrecord;

BEGIN
   Typen_Menge:= [booleanT];
   Xinput (Message, Typen_Menge, Typen_Record);
   get_boolean:= Typen_Record.booleanX;
END;

(*-------------------------------------------------------------------*)

PROCEDURE get_boolean_inkl (    Message   :T_Message_Str;
                            VAR Entscheid :boolean;
                            VAR Eingabe   :boolean);

   VAR
       Typen_Menge  :T_Typenmenge;
       Typen_Record :T_Typenrecord;

BEGIN
   Typen_Menge:= [booleanT, NullT];
   Xinput (Message, Typen_Menge, Typen_Record);
   Entscheid:= Typen_Record.booleanX;
   Eingabe:= not (NullT in Typen_Menge);
END;

(*------------------------------------------------------------------------*)

FUNCTION get_char  (Message: T_Message_Str): char;

   VAR
      Typen_Menge    :T_Typenmenge;
      Typen_Record   :T_Typenrecord;

BEGIN
   Typen_Menge:= [charT];
   Xinput (Message, Typen_Menge, Typen_Record);
   get_char:= Typen_Record.charX;
END;

(*-------------------------------------------------------------------*)

FUNCTION get_m_char (Message       :T_Message_Str;
                     possible_char :T_char_Menge): char;

   VAR
      possible   :boolean;
      Eingabe    :char;

BEGIN
   REPEAT
      Eingabe:= get_char (Message);
      IF not (Eingabe in possible_char) THEN BEGIN
         possible:= false;
         XError ('impossible character');
      END
      ELSE BEGIN
         possible:= true;
      END;
   UNTIL possible;
   get_m_char:= Eingabe;
END;

(*-------------------------------------------------------------------*)

PROCEDURE get_char_inkl (    Message   :T_Message_Str;
                         VAR Zeichen   :char;
                         VAR Eingabe   :boolean);

   VAR
       Typen_Menge  :T_Typenmenge;
       Typen_Record :T_Typenrecord;

BEGIN
   Typen_Menge:= [charT, NullT];
   Xinput (Message, Typen_Menge, Typen_Record);
   Zeichen:= Typen_Record.charX;
   Eingabe:= not (NullT in Typen_Menge);
END;

(*------------------------------------------------------------------------*)

FUNCTION get_integer  (Message  :T_Message_Str): integer;

   VAR  Typen_Menge    :T_Typenmenge;
        Typen_Record   :T_Typenrecord;

BEGIN
   Typen_Menge:= [integerT];
   Xinput (Message, Typen_Menge, Typen_Record);
   get_integer:= Typen_Record.integerX;
END;

(*-------------------------------------------------------------------*)

FUNCTION get_m_integer  (Message   :T_Message_Str;
                         low, high :integer): integer;

   VAR
      possible   :boolean;
      Eingabe    :integer;

BEGIN
   REPEAT
      Eingabe:= get_integer (Message);
      IF (Eingabe < low) or (Eingabe > high) THEN BEGIN
         IF (Eingabe < low) THEN BEGIN
            XError ('too low');
         END
         ELSE BEGIN
            XError ('too high');
         END;
         possible:= false;
      END
      ELSE BEGIN
         possible:= true;
      END;
   UNTIL possible;
   get_m_integer:= Eingabe;
END;

(*------------------------------------------------------------------------*)

PROCEDURE get_integer_inkl (    Message   :T_Message_Str;
                            VAR Zahl      :integer;
                            VAR Eingabe   :boolean);

   VAR
       Typen_Menge  :T_Typenmenge;
       Typen_Record :T_Typenrecord;

BEGIN
   Typen_Menge:= [integerT, NullT];
   Xinput (Message, Typen_Menge, Typen_Record);
   Zahl:= Typen_Record.integerX;
   Eingabe:= not (NullT in Typen_Menge);
END;

(*------------------------------------------------------------------------*)

FUNCTION get_real     (Message       :T_Message_Str): real;

   VAR
      Typen_Menge     :T_Typenmenge;
      Typen_Record    :T_Typenrecord;

BEGIN
   Typen_Menge:= [realT];
   Xinput (Message, Typen_Menge, Typen_Record);
   get_real:= Typen_Record.realX;
END;

(*-------------------------------------------------------------------*)

FUNCTION get_m_real (Message   :T_Message_Str;
                     low, high :real          ): real;

   VAR
      possible   :boolean;
      Eingabe    :real;

BEGIN
   REPEAT
      Eingabe:= get_real (Message);
      IF (Eingabe < low) or (Eingabe > high) THEN BEGIN
         IF (Eingabe < low) THEN BEGIN
            XError ('too low');
         END
         ELSE BEGIN
            XError ('too high');
         END;
         possible:= false;
      END
      ELSE BEGIN
         possible:= true;
      END;
   UNTIL possible;
   get_m_real:= Eingabe;
END;

(*-------------------------------------------------------------------*)

PROCEDURE get_real_inkl (    Message   :T_Message_Str;
                         var Zahl      :real;
                         var Eingabe   :boolean);

   VAR
       Typen_Menge  :T_Typenmenge;
       Typen_Record :T_Typenrecord;

BEGIN
   Typen_Menge:= [realT, NullT];
   Xinput (Message, Typen_Menge, Typen_Record);
   Zahl:= Typen_Record.realX;
   Eingabe:= not (NullT in Typen_Menge);
END;

(*-------------------------------------------------------------------*)

FUNCTION get_String   (Message   :T_Message_Str): T_Enter_String;

   VAR
      Typen_Menge    :T_Typenmenge;
      Typen_Record   :T_Typenrecord;

BEGIN
   Typen_Menge:= [StringT];
   Xinput (Message, Typen_Menge, Typen_Record);
   get_String:= Typen_Record.StringX;
END;

(*-------------------------------------------------------------------*)

FUNCTION get_m_String (Message   : T_Message_Str;
                       max_Length: integer       ): T_Enter_String;

   VAR
      possible  :boolean;
      Eingabe   :T_Enter_String;

BEGIN
   REPEAT
      Eingabe:= get_String (Message);
      IF (length (Eingabe) > max_Length) THEN BEGIN
         XError ('String too long');
         possible:= false;
      END
      ELSE BEGIN
         possible:= true;
      END;
   UNTIL possible;
   get_m_String:= Eingabe;
END;

(*------------------------------------------------------------------------*)

PROCEDURE get_String_inkl (    Message   :T_Message_Str;
                           VAR Wort      :T_Enter_String;
                           VAR Eingabe   :boolean);

   VAR
       Typen_Menge  :T_Typenmenge;
       Typen_Record :T_Typenrecord;

BEGIN
   Typen_Menge:= [StringT, NullT];
   Xinput (Message, Typen_Menge, Typen_Record);
   Wort:= Typen_Record.StringX;
   Eingabe:= not (NullT in Typen_Menge);
END;

(*------------------------------------------------------------------------*)

PROCEDURE get_Keypressed (Message  :T_Message_Str);

   VAR
      Cx, Cy  :integer;

BEGIN
   Cursor_safe (Cx, Cy);
   gotoXY (1, Enter_Line);
   delLine;
   write (Message);
   REPEAT
   UNTIL KeyPressed;
   Cursor_return (Cx, Cy);
END;