(*************************************************************************
*                                                                        *
*    package  INPUT & TEST  from unit  NUMERIK                           *
*                                                                        *
**************************************************************************
    *                                                                    *
    *  J. Desteffani IA85                     01.01.1987 - 02.02.1987    *
    *                                                                    *
    *  p u r p o s e :                                                   *
    *    Liest eine Eingabe und wertet sie sogleich aus.                 *
    *    Die Auswertung erscheint in der Variable [Eingabe].             *
    *                                                                    *
    *  e n t r i e s :                                                   *
    *    PROCEDURE get_Befehl (VAR x: T_Eingabe);                        *
    *    FUNCTION  Argument_Test (Argument: T_Enter_String)              *
    *                                               :T_Matrix_Zeiger;    *
    *                                                                    *
    **********************************************************************)


FUNCTION Befehl_Test (x: T_Enter_String): T_Befehl;

   VAR
      a  :T_Befehl;

BEGIN
   a:= no;
   IF x = 'add'      THEN a:= add     ;
   IF x = 'aitken'   THEN a:= aitken  ;
   IF x = 'cholesky' THEN a:= cholesky;
   IF x = 'clear'    THEN a:= clear   ;
   IF x = 'del'      THEN a:= del     ;
   IF x = 'det'      THEN a:= det     ;
   IF x = 'display'  THEN a:= display ;
   IF x = 'edit'     THEN a:= edit    ;
   IF x = 'eps'      THEN a:= eps     ;
   IF x = 'euler'    THEN a:= euler   ;
   IF x = 'exit'     THEN a:= exit    ;
   IF x = 'eye'      THEN a:= eye     ;
   IF x = 'help'     THEN a:= help    ;
   IF x = 'input'    THEN a:= input   ;
   IF x = 'inv'      THEN a:= inv     ;
   IF x = 'lagrange' THEN a:= lagrange;
   IF x = 'lin'      THEN a:= lin     ;
   IF x = 'list'     THEN a:= list    ;
   IF x = 'load'     THEN a:= load    ;
   IF x = 'long'     THEN a:= long    ;
   IF x = 'lr'       THEN a:= lr      ;    (* list result *)
   IF x = 'lu'       THEN a:= lu      ;    (* LU - Zerlegung *)
   IF x = 'mult'     THEN a:= mult    ;
   IF x = 'no'       THEN a:= no      ;
   IF x = 'pivot'    THEN a:= pivot   ;
   IF x = 'plot'     THEN a:= plot    ;
   IF x = 'polytab'  THEN a:= polytab ;
   IF x = 'prim'     THEN a:= prim    ;
   IF x = 'qr'       THEN a:= qr      ;    (* QR - Zerlegung *)
   IF x = 'rand'     THEN a:= rand    ;
   IF x = 'rank'     THEN a:= rank    ;
   IF x = 'report'   THEN a:= report  ;
   IF x = 'result'   THEN a:= result  ;
   IF x = 'save'     THEN a:= save    ;
   IF x = 'short'    THEN a:= short   ;
   IF x = 'spline'   THEN a:= spline  ;
   IF x = 'sr'       THEN a:= sr      ;    (* store result *)
   IF x = 'status'   THEN a:= status  ;
   IF x = 'store'    THEN a:= store   ;
   IF x = 'sub'      THEN a:= sub     ;
   IF x = 'transp'   THEN a:= transp  ;
   Befehl_Test:= a;
END;

(*------------------------------------------------------------------------*)

FUNCTION Art_Test (Befehl: T_Befehl): integer;

BEGIN
   WITH Eingabe DO BEGIN

      (*------------------------------------------------
       |                                                |
       |    falsche Befehle                             |
       |                                                |
        ------------------------------------------------*)

      IF Befehl in [no] THEN BEGIN
         Art_Test:= 0;
         N_Error (10);
         exit;
      END;

      (*------------------------------------------------
       |                                                |
       |    Befehle die 1 Argument  verlangen           |
       |                                                |
        ------------------------------------------------*)

      IF (Befehl in [cholesky, clear, del, eye, inv, list, load, rank,
                     transp, plot, display, qr, lagrange,
                     spline, save, edit, det, lu, sr, rand, polytab]) and
         (Arg[2]<>'') and  (Arg[3]='') THEN BEGIN

         Art_Test:= 1;
         IF (length(Arg[2]) > maxArgLaenge) THEN BEGIN
            Error_Arg:= Arg[2];
            N_Error (49);
            Art_Test:= 0;
            exit;
         END;
         IF (Nr[2] = nil) THEN BEGIN
            IF (Befehl in [eye, load, sr, rand]) THEN BEGIN
               Art_Test:= 8;
            END
            ELSE BEGIN
               Error_Arg:= Arg[2];
               N_Error (45);
               Art_Test:= 0;
            END;
         END;
         exit;
      END;

      (*------------------------------------------------
       |                                                |
       |    Befehle die 2 Argumente verlangen           |
       |                                                |
        ------------------------------------------------*)

      IF (Befehl in [add, store, lin, load, save, sub, mult]) and
         (Arg[2]<>'') and (Arg[3]<>'') THEN BEGIN

         Art_Test:= 2;
         IF ((length(Arg[2]) > maxArgLaenge) or
            (length(Arg[3]) > maxArgLaenge)) THEN BEGIN
            IF length(Arg[2]) > maxArgLaenge
            THEN Error_Arg:= Arg[2]
            ELSE Error_Arg:= Arg[3];
            N_Error (49);
            Art_Test:= 0;
            exit;
         END;
         IF (Befehl in [load]) THEN BEGIN
            Art_Test:= 9;
            exit;
         END;
         IF (Nr[2] = nil) THEN BEGIN
            Error_Arg:= Arg[2];
            N_Error (45);
            Art_Test:= 0;
            exit;
         END;
         IF (Nr[3] = nil) THEN BEGIN
            IF (Befehl in [save, store]) THEN BEGIN
               Art_Test:= 7;
            END
            ELSE BEGIN
               Error_Arg:= Arg[3];
               N_Error (45);
               Art_Test:= 0;
            END;
         END;
         exit;
      END;

      (*------------------------------------------------
       |                                                |
       |    Befehle die 1 Befehls-Argument verlangen    |
       |                                                |
        ------------------------------------------------*)

      IF (Befehl in [help, result, report, pivot, short, long]) and
         ((Arg[2]<>'') and (Arg[3]='')) THEN BEGIN

         Art_Test:= 3;
         IF (Bef[2] = no) and (Befehl in [help]) THEN BEGIN
            Error_Arg:= Arg[2];
            N_Error (47);
            Art_Test:= 0;
         END;
         exit;
      END;

      (*------------------------------------------------
       |                                                |
       |    Befehle die eine Zahl verlangen             |
       |                                                |
        ------------------------------------------------*)

      IF (Befehl in [euler, prim, eps]) and
         ((Arg[2]<>'') and (Arg[3]='') and (Zahl[2]<>word)) THEN BEGIN

         Art_Test:= 4;
         IF (Zahl[2] <> Zinteger) and (Befehl in [euler]) THEN BEGIN
            N_Error (42);
            Art_Test:= 0;
         END;
         exit;
      END;

      (*------------------------------------------------
       |                                                |
       |    alleinstehende Befehle                      |
       |                                                |
        ------------------------------------------------*)

      IF (Befehl in [del, save, status, lr, aitken,
                     exit, help, list, long, short]) and
         (Arg[2]='') THEN BEGIN
         Art_Test:= 5; exit;
      END;

      (*------------------------------------------------
       |                                                |
       |   Befehle die 1 beliebiges Argument verlangen  |
       |                                                |
        ------------------------------------------------*)

      IF (Befehl in [input]) and
         (Arg[2]<>'') and (Arg[3]='') THEN BEGIN
         Art_Test:= 6;
         IF (length(Arg[2]) > maxArgLaenge) THEN BEGIN
            Error_Arg:= Arg[2];
            N_Error (49);
            Art_Test:= 0;
            exit;
         END;
         exit;
      END;
   END;
   Art_Test:= 0;
   N_Error (40);
END;

(*------------------------------------------------------------------------*)

FUNCTION Argument_Test (Argument: T_Enter_String): T_Matrix_Zeiger;

   VAR
      Zeiger  :T_Matrix_Zeiger;

BEGIN
   Argument_Test:= nil;
   Zeiger:= Matrizen;
   WHILE Zeiger <> nil DO BEGIN
      IF Zeiger^.Name = Argument THEN BEGIN
         Argument_Test:= Zeiger;
         Zeiger:= nil;
      END
      ELSE BEGIN
         Zeiger:= Zeiger^.next;
      END;
   END;
END;

(*------------------------------------------------------------------------*)

FUNCTION Zahl_Test (    Argument: T_Enter_String;
                    VAR r: real; VAR i: integer): T_Zahl_Typen;

   VAR
      Typen_Menge  :T_Typenmenge;
      Typen_Record :T_Typenrecord;

BEGIN
   r:= 0.0;
   i:= 0;
   Zahl_Test:= word;
   Typ_Test (Argument, Typen_Menge, Typen_Record);
   IF (integerT in Typen_Menge) or (realT in Typen_Menge) THEN BEGIN
      r:= Typen_Record.realX;
      IF (integerT in Typen_Menge) THEN BEGIN
         i:= Typen_Record.integerX;
         Zahl_Test:= Zinteger;
      END
      ELSE BEGIN
         Zahl_Test:= Zreal;
      END;
   END;
END;

(*------------------------------------------------------------------------*)

PROCEDURE ltrim (VAR Word: T_Enter_String);
BEGIN
   WHILE (Word[1] = ' ') and (length(Word) > 0) DO BEGIN
      Word:= copy (Word, 2, length(Word)-1);
   END;
END;


PROCEDURE trim (VAR Word: T_Enter_String);
BEGIN
   WHILE (Word[length(Word)] = ' ') and (length(Word) > 0) DO BEGIN
      Word:= copy (Word, 1, length(Word)-1);
   END;
END;

(*------------------------------------------------------------------------*)

PROCEDURE get_Befehl (var x: T_Eingabe);

   VAR
      Art, j     :integer;
      Word       :T_Enter_String;


   FUNCTION get_Word (VAR Satz: T_Enter_String): T_Enter_String;
      VAR
         j       :integer;
   BEGIN
      j:= 1;
      WHILE (Satz[j] <> ' ') and (length(Satz) > j) DO BEGIN
         j:= j +1;
      END;
      IF (length(Satz) <> j) THEN BEGIN
         get_Word:= copy (Satz, 1, j-1);
         Satz:= copy (Satz, j, length(Satz)-j+1);
      END
      ELSE BEGIN
         get_Word:= Satz;
         Satz:= '';
      END;
   END;


BEGIN
   Window_off;
   Eingabe.Satz:= get_m_String (': ',50);
   Window_on;
   If new_run THEN BEGIN
      title;
      new_run:= false;
   END;
   trim(Eingabe.Satz);
   WITH Eingabe DO BEGIN
      FOR j:= 1 TO AnzArg DO BEGIN
         ltrim(Satz);
         Arg[j]:= get_Word(Satz);
         Bef[j]:= Befehl_Test(Arg[j]);
         Nr[j]:= Argument_Test(Arg[j]);
         Zahl[j]:= Zahl_Test(Arg[j], r[j], i[j]);
      END;
      Art:= Art_Test(Bef[1]);
      IF Art = 0 THEN BEGIN
         clrEingabe;
      END;
   END;
END;
