(*************************************************************************
*                                                                        *
*    package  INTERN  from unit  NUMERIK                                 *
*                                                                        *
**************************************************************************
    *                                                                    *
    *  J. Desteffani IA85                     01.01.1987 - 06.02.1987    *
    *                                                                    *
    *  p u r p o s e :                                                   *
    *    Fuehrt interne Matrizenmanipulationen aus.                      *
    *    (Keine Berechnungen!)                                           *
    *                                                                    *
    *  e n t r i e s :                                                   *
    *    PROCEDURE del_Intern          (    Zeiger: T_Matrix_Zeiger);    *
    *    PROCEDURE load_Intern         (    Zeiger: T_Matrix_Zeiger);    *
    *    FUNCTION  get_Matrix_Zeiger   (    Name: T_Enter_String):       *
    *                                                   T_Matrix_Zeiger; *
    *    PROCEDURE save_Intern         (VAR Feld: T_Matrix_Intern);      *
    *    PROCEDURE load_Intern_Tabelle (    Zeiger_T_Matrix_Zeiger;      *
    *                                   VAR Tab: T_Tabelle);             *
    *    PROCEDURE save_Intern_Tabelle (VAR Tab: T_Tabelle);             *
    *    PROCEDURE do_store;                                             *
    *    PROCEDURE do_sr;                                                *
    *                                                                    *
    **********************************************************************)

PROCEDURE del_Intern (Zeiger: T_Matrix_Zeiger);

   VAR x, y   :T_Daten_Zeiger;

BEGIN
   x:= Zeiger^.Wurzel;
   IF Zeiger^.vor <> nil THEN BEGIN
      IF Zeiger^.next <> nil THEN BEGIN
         Zeiger^.vor^.next:= Zeiger^.next;
         Zeiger^.next^.vor:= Zeiger^.vor;
      END
      ELSE BEGIN
         Zeiger^.vor^.next:= nil;
      END;
   END
   ELSE BEGIN
      IF Zeiger^.next <> nil THEN BEGIN
         Zeiger^.next^.vor:= nil;
         Matrizen:= Zeiger^.next;
      END
      ELSE BEGIN
         Matrizen:= nil;
      END;
   END;
   dispose (Zeiger);
   WHILE x^.next <> nil DO BEGIN
      y:= x;
      x:= x^.next;
      dispose (y);
   END;
   dispose (x);
END;

(*------------------------------------------------------------------------*)

PROCEDURE Load_Intern (Zeiger: T_Matrix_Zeiger; VAR Feld: T_Matrix_Intern);

   VAR
      i, j   :integer;
      t      :T_Daten_Zeiger;

BEGIN
   Feld.Name:= Zeiger^.Name;
   IF Zeiger^.n > 50  THEN BEGIN
      Feld.n:= 50;
      (* Error_Arg:= Zeiger^.Name;
         N_Error (81);
      *)
   END
   ELSE BEGIN
      Feld.n:= Zeiger^.n;
   END;
   Feld.m:= Zeiger^.m;
   t:= Zeiger^.Wurzel;
   FOR i:= 1 TO Feld.n DO BEGIN
      FOR j:= 1 TO Feld.m DO BEGIN
         IF t = nil THEN BEGIN
            Error_Arg:= Zeiger^.Name;
            N_Error (520);
            exit;
         END;
         Feld.x[i,j]:= t^.Zahl;
         t:= t^.next;
      END;
   END;
END;

(*------------------------------------------------------------------------*)

FUNCTION get_Matrix_Zeiger (Name: T_Enter_String): T_Matrix_Zeiger;

   VAR
      Zeiger, neuer, safe  :T_Matrix_Zeiger;

BEGIN
   Zeiger:= Matrizen;
   new (neuer);
   IF Zeiger <> nil THEN BEGIN
      WHILE (Zeiger <> nil) DO BEGIN
         safe:= Zeiger;
         IF Zeiger^.Name = Name THEN BEGIN
            del_Intern (Zeiger);
            Zeiger:= Matrizen;
            safe:= Matrizen;
         END
         ELSE BEGIN
            Zeiger:= Zeiger^.next;
         END;
      END;
      IF Matrizen <> nil THEN BEGIN
         safe^.next:= neuer;
         neuer^.vor:= safe;
      END
      ELSE BEGIN
         Matrizen:= neuer;
         neuer^.vor:= nil;
      END;
   END
   ELSE BEGIN
      Matrizen:= neuer;
      neuer^.vor:= nil;
   END;
   neuer^.next:= nil;
   neuer^.Wurzel:= nil;
   get_Matrix_Zeiger:= neuer;
END;

(*------------------------------------------------------------------------*)

PROCEDURE save_Intern (VAR Feld: T_Matrix_Intern);

   VAR
      i, j       :integer;
      x, safe    :T_Daten_Zeiger;
      Zeiger     :T_Matrix_Zeiger;

BEGIN
   Zeiger:= get_Matrix_Zeiger (Feld.Name);
   Zeiger^.Name:= Feld.Name;
   Zeiger^.n:= Feld.n;
   Zeiger^.m:= Feld.m;
   new(x);
   x^.next:= nil;
   Zeiger^.Wurzel:= x;
   FOR i:= 1 TO Feld.n DO BEGIN
      FOR j:= 1 TO Feld.m DO BEGIN
         x^.Zahl:= Feld.x[i,j];
         new (x^.next);
         safe:= x;
         x:= x^.next;
      END;
   END;
   dispose (x);
   safe^.next:= nil;
END;

(*------------------------------------------------------------------------*)

PROCEDURE Load_Intern_Tabelle (Zeiger: T_Matrix_Zeiger; VAR Tab: T_Tabelle);

   VAR
      i, j   :integer;
      t      :T_Daten_Zeiger;

BEGIN
   Tab.Name:= Zeiger^.Name;
   Tab.n:= Zeiger^.n;
   Tab.m:= 2;
   (* IF Tab.m <> 2 THEN BEGIN
         Error_Arg:= Zeiger^.Name;
         N_Error (68);
      END;
   *)
   t:= Zeiger^.Wurzel;
   FOR i:= 1 TO Tab.n DO BEGIN
      FOR j:= 1 TO Tab.m DO BEGIN
         IF t = nil THEN BEGIN
            N_Error (520);
            exit;
         END;
         IF j <= 2 THEN BEGIN
            Tab.x[i,j]:= t^.Zahl;
            t:= t^.next;
         END;
      END;
   END;
END;

(*------------------------------------------------------------------------*)

PROCEDURE Save_Intern_Tabelle (VAR Tab: T_Tabelle);

   VAR
      i, j       :integer;
      x, safe    :T_Daten_Zeiger;
      Zeiger     :T_Matrix_Zeiger;

BEGIN
   Zeiger:= get_Matrix_Zeiger (Tab.Name);
   Zeiger^.Name:= Tab.Name;
   Zeiger^.n:= Tab.n;
   Zeiger^.m:= 2;
   new(Zeiger^.Wurzel);
   x^.next:= nil;
   x:= Zeiger^.Wurzel;
   FOR i:= 1 TO Tab.n DO BEGIN
      FOR j:= 1 TO 2 DO BEGIN
         x^.Zahl:= Tab.x[i,j];
         new (x^.next);
         safe:= x;
         x:= x^.next;
      END;
   END;
   dispose (x);
   safe^.next:= nil;
END;

(*------------------------------------------------------------------------*)

PROCEDURE restore (source_matrix, dest_matrix :T_Matrix_Zeiger);

(* .........................................................................
   .                                                                       .
   .  Diese Procedure speichert intern die Matrix mit dem Zeiger           .
   .  <source_matrix> in die Matrix <dest_matrix> ab.                      .
   .  Diese Procedure ist nicht als entry in diesem Package gedacht.       .
   .                                                                       .
   .........................................................................
*)

   VAR
      source, dest  :T_Daten_Zeiger;

BEGIN
   source:= source_matrix^.Wurzel;
   dest_matrix^.n:= source_matrix^.n;
   dest_matrix^.m:= source_matrix^.m;
   IF source <> nil THEN BEGIN
      new (dest_matrix^.Wurzel);
      dest:= dest_Matrix^.Wurzel;
      REPEAT
         dest^.Zahl:= source^.Zahl;
         source:= source^.next;
         IF source <> nil THEN BEGIN
            new (dest^.next);
            dest:= dest^.next;
         END;
      UNTIL source = nil;
      dest^.next:= nil;
   END
   ELSE BEGIN
      N_Error (520);
      exit;
   END;
END;

(*------------------------------------------------------------------------*)

PROCEDURE do_store;

(* .........................................................................
   .                                                                       .
   . Diese Procedure kopiert intern die Matrix mit Namen (Eingabe.Arg[2])  .
   . in die Matrix mit Namen (Eingabe.Arg[3]).                             .
   . Die alte Matrix bleibt erhalten.                                      .
   .                                                                       .
   .........................................................................
*)

   VAR
      new_Zeiger  :T_Matrix_Zeiger;

BEGIN
   new_Zeiger:= get_Matrix_Zeiger (Eingabe.Arg[3]);
   new_Zeiger^.Name:= Eingabe.Arg[3];
   restore (Eingabe.Nr[2], new_Zeiger)
END;

(*------------------------------------------------------------------------*)

PROCEDURE do_sr;

(* .........................................................................
   .                                                                       .
   . Diese Procedure kopiert intern die Matrix mit Namen (Result_Name)     .
   . in die Matrix mit Namen (Eingabe.Arg[3]).                             .
   . Die alte Matrix bleibt erhalten.  (sr = store result)                 .
   .                                                                       .
   .........................................................................
*)
   VAR
      source, dest   :T_Matrix_Zeiger;

BEGIN
   source:= Matrizen;
   WHILE source <> nil DO BEGIN
      IF source^.Name = Result_Name THEN BEGIN
         dest:= get_Matrix_Zeiger (Eingabe.Arg[2]);
         dest^.Name:= Eingabe.Arg[2];
         restore (source, dest);
         exit;
      END
      ELSE BEGIN
         source:= source^.next;
      END;
   END;
   N_Error (220);
END;

