(*************************************************************************
*                                                                        *
*    procedure  POLT-TABELLE  from package  NUMERIK                      *
*                                                                        *
**************************************************************************
    *                                                                    *
    *  J. Desteffani IA85                     03.02.1987 - 03.02.1987    *
    *                                                                    *
    *  p u r p o s e :                                                   *
    *    Berechnet eine Tablle von Punkten. Die Funktion ist das Polynom *
    *    welches durch die Matrix spezifiziert wurde. Die Matrix ist     *
    *    eine Zeilenmatrix. (Andernfalls wird die erste Zeile verwendet) *
    *    An erster Stelle steht der Koeffizient von x^0 an n-ter Stelle  *
    *    der Koeffizient von x^(n-1).                                    *
    *                                                                    *
    *  e n t r i e s :                                                   *
    *    PROCEDURE do_polytab;                                           *
    *                                                                    *
    **********************************************************************)

PROCEDURE do_polytab;

   VAR
      low, high,
      Neustelle, step    :real;
      k, n               :integer;
      Polynom            :T_Matrix_Intern;
      Tabelle            :T_Tabelle;


   FUNCTION get_Point (Neustelle :real): real;

      VAR
         i   :integer;
         x   :real;

   BEGIN
      x:= 0;
      FOR i:= Polynom.m DOWNTO 1 DO BEGIN
         x:= Polynom.x[1,i] + (x * Neustelle);
      END;
      get_Point:= x;
   END;


BEGIN
   Load_Intern (Eingabe.Nr[2], Polynom);
   low:= N_real_Ask (10);
   high:= N_real_Ask (11);
   IF high < low THEN BEGIN
      N_Error (28);
      exit;
   END;
   n:= N_integer_Ask (10);
   Tabelle.n:= n;
   Tabelle.m:= 2;
   Tabelle.Name:= Result_Name;
   step:= (high - low)/(n - 1);
   Neustelle:= low;
   FOR k:= 1 TO n DO BEGIN
      Tabelle.x[k,1]:= Neustelle;
      Tabelle.x[k,2]:= get_Point (Neustelle);
      Neustelle:= Neustelle + step;
   END;
   save_Intern_Tabelle (Tabelle);
   N_Message (9);
END;
