(*************************************************************************
*                                                                        *
*    PACKAGE   S T A T U S   from   N U M E R I K                        *
*                                                                        *
**************************************************************************
    *                                                                    *
    *  J. Desteffani IA85                     01.01.1987 - 26.01.1987    *
    *                                                                    *
    *  p u r p o s e :                                                   *
    *    Proceduren welche den Zustand des Programmes veraendern.        *
    *                                                                    *
    *  e n t r i e s :                                                   *
    *    PROCEDURE do_pivot;    - Pivotierung on/off                     *
    *    PROCEDURE do_short;    - Zahlenformat short (e)                 *
    *    PROCEDURE do_long;     - Zahlenformat long (e)                  *
    *    PROCEDURE do_result;   - Resultatanzeige on/off                 *
    *    PROCEDURE do_report;   - Reportanzeige on/off                   *
    *    PROCEDURE do_eps;      - Veraendern des Singularitaetskriteriums*
    *    PROCEDURE do_status;   - Anzeige der Statusdaten                *
    *    FUNCTION  do_exit;     - Ausstieg aus Programm                  *
    *                                                                    *
    **********************************************************************)

PROCEDURE do_pivot;
BEGIN
   IF (Eingabe.Arg[2] = 'on') or (Eingabe.Arg[2] = 'off') THEN BEGIN
      Pivot_Enable:= (Eingabe.Arg[2] = 'on');
   END
   ELSE BEGIN
      N_Error (47);
   END;
END;

(*------------------------------------------------------------------------*)

PROCEDURE do_short;
BEGIN
   IF Eingabe.Arg[2] = 'e' THEN BEGIN
      Format:= kurz_exp;
      exit;
   END;
   IF Eingabe.Arg[2] = '' THEN BEGIN
      Format:= kurz;
      exit;
   END;
   N_Error (47);
END;

(*------------------------------------------------------------------------*)

PROCEDURE do_long;
BEGIN
   IF Eingabe.Arg[2] = 'e' THEN BEGIN
      Format:= lang_exp;
      exit;
   END;
   IF Eingabe.Arg[2] = '' THEN BEGIN
      Format:= lang;
      exit;
   END;
   N_Error (47);
END;

(*------------------------------------------------------------------------*)

PROCEDURE do_result;
BEGIN
   IF (Eingabe.Arg[2] = 'on') or (Eingabe.Arg[2] = 'off') THEN BEGIN
      Result_Enable:= (Eingabe.Arg[2] = 'on');
   END
   ELSE BEGIN
      N_Error (47);
   END;
END;

(*------------------------------------------------------------------------*)

PROCEDURE do_report;
BEGIN
   IF (Eingabe.Arg[2] = 'on') or (Eingabe.Arg[2] = 'off') THEN BEGIN
      Report_Enable:= (Eingabe.Arg[2] = 'on');
   END
   ELSE BEGIN
      N_Error (47);
   END;
END;

(*------------------------------------------------------------------------*)

PROCEDURE do_eps;
BEGIN
   Epsilon:= abs (Eingabe.r[2]);
END;

(*------------------------------------------------------------------------*)

PROCEDURE do_status;

   PROCEDURE on_off (a :boolean);
   BEGIN
      IF a
      THEN writeln ('  ON')
      ELSE writeln (' OFF');
   END;

   PROCEDURE short_long (a :T_Format);
   BEGIN
      CASE a OF
      kurz     :writeln ('short');
      kurz_exp :writeln ('short & Exponent');
      lang     :writeln ('long');
      lang_exp :writeln ('long & Exponent');
      END;
   END;

BEGIN
   writeln; writeln;
   write ('pivot               :'); on_off (Pivot_Enable);
   write ('report              :'); on_off (Report_Enable);
   write ('result              :'); on_off (Result_Enable);
   write ('format              :'); short_long (Format);
   writeln ('epsilon             :', Epsilon);
   writeln ('max. matrix-index   :', Max_Ind:4);
   write ('max. tabellen-index :', Max_Ind_Tabelle:4);
END;

(*------------------------------------------------------------------------*)

PROCEDURE do_exit;
BEGIN
   leave:= N_Ask (2);
   IF not leave THEN N_Message (11);
END;
